unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LR_Class, LR_Desgn, Forms, Controls,
  Graphics, Dialogs, StdCtrls, Spin, LazUTF8;

type

  { TForm1 }

  TForm1 = class(TForm)
    Editor: TButton;
    frDesigner1: TfrDesigner;
    Label7: TLabel;
    ParamMemo: TMemo;
    Preview: TButton;
    ComboBox1: TComboBox;
    Edit1: TEdit;
    Edit2: TEdit;
    FloatSpinEdit1: TFloatSpinEdit;
    frReport1: TfrReport;
    Label1: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Memo1: TMemo;
    SpinEdit1: TSpinEdit;
    procedure EditorClick(Sender: TObject);
    procedure frReport1GetValue(const ParName: String; var ParValue: Variant);
    procedure PreviewClick(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.frReport1GetValue(const ParName: String; var ParValue: Variant
  );
var
  i: Integer;
begin
  for i:=0 to ComponentCount-1 do
  begin
    if UpperCase(ParName)=UpperCase(Components[i].Name) then
    begin
      case Components[i].ClassName of
      'TEdit': ParValue:=(Components[i] as TEdit).Text;
      'TComboBox': ParValue:=(Components[i] as TComboBox).Text;
      'TLabel': ParValue:=(Components[i] as TLabel).Caption;
      'TButton': ParValue:=(Components[i] as TButton).Caption;
      'TMemo': ParValue:=(Components[i] as TMemo).Lines.Text;
      'TSpinEdit': ParValue:=(Components[i] as TSpinEdit).Value;
      'TFloatSpinEdit': ParValue:=(Components[i] as TFloatSpinEdit).Value;
      end;
    end;
  end;
  for i:=0 to ParamMemo.Lines.Count-1 do
  begin
    if UTF8Pos(':', ParamMemo.Lines[i])>1 then
    begin
      if UTF8UpperCase(ParName)=UTF8UpperCase(UTF8Copy(ParamMemo.Lines[i], 1, UTF8Pos(':', ParamMemo.Lines[i])-1)) then
      ParValue:=UTF8Copy(ParamMemo.Lines[i], UTF8Pos(':', ParamMemo.Lines[i])+1, UTF8Length(ParamMemo.Lines[i])-UTF8Pos(':', ParamMemo.Lines[i]));
    end;
  end;
end;

procedure TForm1.EditorClick(Sender: TObject);
begin
  frReport1.LoadFromFile('report.lrf');
  frReport1.DesignReport;
end;

procedure TForm1.PreviewClick(Sender: TObject);
begin
  frReport1.LoadFromFile('report.lrf');
  frReport1.ShowReport;
end;

end.

